<?php
/*	ctypedb : card type database
	name : C-Type db
	author: team1/3
	
	copy from sample_folder_page.php
*/

	global $params,$config;

	if (!isset($config)) { die(); }
	$params['thumb_width']=400;
	$params['thumb_height']=400;
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];
	provide_onethird_object();
	
$html['css']['ctypedb-draw'] = <<<EOT
	<style>
	.onethird-ctypedb .table {
		display:table;
	}
	.onethird-ctypedb .left-unit {
		display:inline-block;
		min-width:100px;
		border: 1px solid #c0c0c0;
	}
	.onethird-ctypedb .mid-unit {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:0 5px;
	}
	.onethird-ctypedb .image-panel {
		display:inline-block;
		width:300px;
		height:190px;
		overflow: hidden;
	}
	.onethird-ctypedb .image-panel img {
		width:100%;
	}
	.onethird-ctypedb .item-panel {
		position: relative;
		display:table;
		width: 100%;
	    margin: 5px 0;
	}
	.onethird-ctypedb .item-panel div.left {
		display:inline-block;
		min-width:150px;
		background-color: rgb(212, 211, 211);
		padding:2px 7px;
		min-height:30px;
		margin-right: 6px;
		height: 100%;
	}
	#_tryitEditor_contents .onethird-ctypedb .item-panel div.left {
		display:block;
	}
	.onethird-ctypedb .item-panel div.right {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:2px 7px;
		background-color: rgba(220, 220, 220, 0.5);
	}
	.onethird-ctypedb .top-unit , .onethird-ctypedb .bottom-unit{
		width:100%;
		margin: 5px 0;
	}
	.onethird-ctypedb .item {
		min-width:100px;
		display: inline-block;
		min-height:20px;
	}
	.onethird-ctypedb .item[data-type=img] {
		width:100%;
		min-height:150px;
	}
	</style>
EOT;

	if (empty($page_ar['meta']['page_ctypedb_parent'])) {
		$page_ar['meta']['page_ctypedb_parent'] = $page_ar['id'];
	}
	if (!is_numeric($page_ar['meta']['page_ctypedb_parent'])) {
		if (isset($params['circle']['meta']['alias'][$page_ar['meta']['page_ctypedb_parent']])) {
			$page_ar['meta']['page_ctypedb_parent'] = $params['circle']['meta']['alias'][$page_ar['meta']['page_ctypedb_parent']];
		}
	}
	if (empty($page_ar['meta']['page_ctypedb_item_count'])) {
		$page_ar['meta']['page_ctypedb_item_count'] = 10;
	}
	if (empty($page_ar['meta']['page_ctypedb_random'])) {
		$page_ar['meta']['page_ctypedb_random'] = false;
	}

	if (PAGE_FOLDER_ID != $page_ar['type'] && $page_ar['link'] && $page_ar['block_type']==10) {
		if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
			// 編集
			provide_edit_module();
			unset($params['breadcrumb']);
			snippet_breadcrumb($p_page, 'Page Edit');
			$buff = page_edit_renderer($page_ar);
			$html['article'][] = frame_renderer($buff);
			return;
		}
		if (read_pagedata($page_ar['link'], $tmp)) {
			if (!empty($tmp['meta']['page_ctypedb_writer'])) {
				$page_ar['meta']['page_ctypedb_writer'] =  $tmp['meta']['page_ctypedb_writer'];
			}
			if (isset($tmp['meta']['format'])) {
				$body = $tmp['meta']['format'];
			} else {
				$body = get_def_format($page_ar);
			}
			$tmp = frame_renderer(body_renderer($page_ar).ctypedb_renderer($page_ar,$body));
			$html['article'][] = custompage_renderer($page_ar['id'],$tmp);
		}
		return;
	}

	if (check_rights('owner')) {
		//ページ作成者にはログインユーザーでも編集権限を与える
		set_func_rights('edit.modules');
		set_func_rights('add_page');
		provide_edit_rights();
		provide_edit_module();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && $_GET['mode'] == 'export') {
		csv_export($page_ar);

	} else if (isset($_GET['mode']) && $_GET['mode'] == 'format') {
		// format編集
		$params['hook']['before_modified'][] = 'ctypedb_onbefore_modified';
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Format Edit');
		snippet_format_js_css();


		$params['hide-editmenu'] = true;
$params['add-editmenu'][] = <<<EOT
		<input type='button' onclick='ot.save_editdata(1)' class='onethird-button mini'  value='save' />
		<input type='button' onclick='ot.open_uploader({select:function(obj){ot.editor.insertimg(obj)}})' class='onethird-button mini' value='image' />
EOT;
		if (isset($page_ar['meta']['format'])) {
			$page_ar['contents'] = $page_ar['meta']['format'];
		} else {
			$page_ar['contents'] = get_def_format($page_ar);
		}
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		ctypedb_menu($page_ar);
		$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分
		if (empty($page_ar['meta']['page_ctypedb_writer'])) {
			ctypedb_folder($page_ar);
		} else {
			if (function_exists($page_ar['meta']['page_ctypedb_writer'])) {
				$page_ar['meta']['page_ctypedb_writer']($page_ar);
			}
		}
		$html['article'][] = innerpage_renderer($page_ar['id']);
	}

	// css style
	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
			.plugin-page-folder-unit {
				margin-bottom:10px;
			}
			.plugin-page-folder-unit p {
				margin:0 0 5px 0;
				padding:0;
			}
			.plugin-page-folder-unit .title {
				color: #286593;
				font-size: 20px;
				margin:0 0 5px 0;
			}
			.plugin-page-folder-unit .onethird-button {
				margin-top:10px;
			}
			.plugin-page-folder-unit .add-panel {
				margin:15px 0 15px 0;
			}
			.plugin-page-folder-unit img {
				vertical-align: middle;
			}
			.plugin-page-folder-unit p .date {
				color:#A0A0A0;
				font-size:90%;
			}
			.plugin-page-folder-unit p .new {
				color:#FF7000;
				padding:0 5px;
			}
		</style>
EOT;
	}

}

function ctypedb_onbefore_modified( &$new_ar )
{
	global $params,$config,$ut;

	if (isset($_GET['mode']) && $_GET['mode'] != 'format') {
		return;
	}
	
	//フォーマットの保存処理
	$new_ar['meta']['format'] = $new_ar['contents'];
	$new_ar['metadata'] = serialize64($new_ar['meta']);
	unset($new_ar['meta']);
	unset($new_ar['contents']);
	if (!mod_data_items($new_ar)) {
		if (isset($_POST['ajax'])) {
			echo( json_encode($r) );
			exit();
		}
		exit_proc(400, 'Save-Error');

	} else {

		if ($new_ar['type'] >= 10) {
			event_plugin_page('onmodified', $new_ar);
		}
		
		if (isset($r['url'])) {
			header("Location: {$r['url']}");
		
		} else {
			if ($new_ar['block_type'] == 5) {
				header("Location: {$ut->link($new_ar['link'])}");
			} else {
				header("Location: {$ut->link($new_ar['id'])}");
			}
		}
		
		exit();
	}
}

function ctypedb_menu( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];
	$parent_page = $page_ar['id'];		//自ページが親ページ

	$allow_post = !empty($page_ar['meta']['page_ctypedb_allow_post']) && check_rights();

	if ($allow_post) {
		set_func_rights('add_data_items');
		provide_edit_rights();
	}
	
	if ($allow_post || isset($params['edit-right']) || check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_ctypedb_make_page')  {
			$r = array();
			$r['link'] = (int)$_POST['page'];
			$r['result'] = false;
			
			if (empty($_POST['type'])) {
				echo( json_encode($r) );
				exit();
			}
			$r['type'] = (int)($_POST['type']);
			$def_format = get_def_format($page_ar);
			if ($r['type'] == PAGE_FOLDER_ID) {
				$r['title'] = 'Folder'.time();
				$r['block_type'] = 10;
				if (isset($page_ar['meta']['format'])) {
					$r['meta']['format'] = $page_ar['meta']['format'];
				} else {
					$r['meta']['format'] = $def_format;
				}
				if ($allow_post) {
					$r['meta']['page_ctypedb_allow_post'] = true;
				}
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
				$r['meta']['lwr_template_ar']['php'] = ".".basename(__FILE__);
			} else {
				$r['title'] = 'DATA-'.substr(time(),-4);
				$r['block_type'] = 10;
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
			}
			create_page( $r );
			
			if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
				unset($r['open_url']);
			}
			echo( json_encode($r) );
			exit();
		}
		if (!isset($html['meta']['plugin_ctypedb_make_page'])) {
$html['meta']['plugin_ctypedb_make_page'] = <<<EOT
			<script>
			ot.plugin_ctypedb_make_page = function (link,type) {
				var opt = "ajax=plugin_ctypedb_make_page";
				opt += "&type="+type+"&page="+link;
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if ( data['open_url'] ) {
								location.href = data['open_url'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

$tmp = <<<EOT
	<a href='{$ut->link($page_ar['id'],'&:mode=export')}' class='onethird-button mini'>CSV export</a>
	<a href='javascript:void(ot.page_ctypedb_setting())' class='onethird-button mini'>Setting</a>
EOT;
	if ($page_ar['meta']['page_ctypedb_parent'] == $page_ar['id']) {
$tmp .= <<<EOT
		<a href='{$ut->link($page_ar['id'],'&:mode=format')}' class='onethird-button mini'>format</a>
EOT;
	}
	$params['add-blockmenu'][] = $tmp;

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","page_ctypedb_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_ctypedb_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $p_id = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];

			if (empty($r['meta']['page_ctypedb_writer'])) {
				$r['meta']['page_ctypedb_writer'] = 'ctypedb_folder';
			}
			$writer_ar = array('ctypedb_folder'=>'ctypedb_folder','gallery_folder'=>'gallery_folder');
			if (!empty($params['page_ctypedb_writer'])) {
				$writer_ar = $params['page_ctypedb_writer'];
			}
$r['html'] = <<<EOT
			<table>
				<tr>
					<td >Writer</td>
					<td>
						{$ut->input(array(
							'type'=>'select'
							, 'data-input'=>'page_ctypedb_writer'
							, 'value'=>$r['meta']['page_ctypedb_writer']
							, 'option'=>$writer_ar
						))}
					</td>
				</tr>
				<tr>
					<td >Parent page</td>
					<td>
						<input type='text' value='{$ut->safe_echo($page_ar['meta']['page_ctypedb_parent'])}' data-input='page_ctypedb_parent' />
					</td>
				</tr>
				<tr>
					<td >Item count</td>
					<td>
						<input type='text' value='{$ut->safe_echo($page_ar['meta']['page_ctypedb_item_count'])}'  data-input='page_ctypedb_item_count' />
					</td>
				</tr>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label>
								<input type='checkbox' data-input='page_ctypedb_allow_post' 
									{$ut->check(!empty($r['meta']['page_ctypedb_allow_post']),'checked')}/> 
									Allow All Users to Submit Posts
								</label>
							</li>
							<li><label>
								<input type='checkbox' data-input='page_ctypedb_random' 
									{$ut->check(!empty($r['meta']['page_ctypedb_random']),'checked')}/> 
									Random list
								</label>
							</li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_ctypedb_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];

			function _option_save_plugin_page_ctypedb_setting($a, &$page_ar) {
				if (isset($_POST[$a])) {
					$page_ar['meta'][$a] = sanitize_str($_POST[$a]);
				} else {
					if (isset($page_ar['meta'][$a])) { unset($page_ar['meta'][$a]); }
				}
			}
			_option_save_plugin_page_ctypedb_setting('page_ctypedb_writer', $r);

			if (isset($_POST['page_ctypedb_allow_post'])) {
				$r['meta']['page_ctypedb_allow_post'] = true;
			} else {
				$r['meta']['page_ctypedb_allow_post'] = false;
			}
			if (isset($_POST['page_ctypedb_parent'])) {
				$r['meta']['page_ctypedb_parent'] = sanitize_asc($_POST['page_ctypedb_parent']);
			} else {
				unset($r['meta']['page_ctypedb_parent']);
			}
			if (isset($_POST['page_ctypedb_random'])) {
				$r['meta']['page_ctypedb_random'] = true;
			} else {
				unset($r['meta']['page_ctypedb_random']);
			}
			if (isset($_POST['page_ctypedb_item_count'])) {
				$r['meta']['page_ctypedb_item_count'] = (int)$_POST['page_ctypedb_item_count'];
			} else {
				unset($r['meta']['page_ctypedb_item_count']);
			}
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}
	}
}
function ctypedb_renderer( &$page_ar,$body )
{
	global $params,$html,$plugin_ar,$config,$ut;
	
	$p_page = $page_ar['id'];
	$type= $page_ar['type'];
	$body = plugin_proc('embed','start').$body.plugin_proc('embed','save');
	$body = preg_replace_callback("/(<span.*?>).*?(<\\/span>)/u",
		function ($matches) {
			global $params,$ut;
			$page_ar = &$params['page'];
			$x = $matches[0];
			preg_match("/data-type=\"(.*?)\" .*?data-name=\"(.*?)\"/u",$x,$m);
			if (!empty($m[1])) {
				if ($m[1] == 'Title') {
					$m[1] = 'text';
					$m[2] = 'title';
				} else if ($m[1] == 'Date') {
					$m[1] = 'date';
					$m[2] = 'date';
				} else if ($m[1] == 'Contents') {
					$m[1] = 'html';
					$m[2] = 'contents';
				} else if ($m[1] == 'select' || $m[1] == 'checkbox' || $m[1] == 'radio') {
					$y = explode(',',$m[2]);
					$m[2] = $y[0];
					array_shift($y);
					return plugin_proc('embed',$m[1],$y,"name:{$m[2]}",'page:self');
				} else if ($m[1] == 'img') {
					return img_proc(array('page'=>'self','name'=>$m[2],"first_mess:Add image"));
				}
				if ($m[1] == 'map') {
					if (!isset($_SESSION['onethird-plugin-embed-on']) && !empty($page_ar['meta']['plugin_embed'][$m[2]])) {
						return "<a href='https://maps.google.co.jp/maps?q=".urlencode($page_ar['meta']['plugin_embed'][$m[2]])."' target='_blank' >{$page_ar['meta']['plugin_embed'][$m[2]]}</a>";
					}
					return plugin_proc('embed','text',"name:{$m[2]}",'page:self');

				} else if ($m[1] == 'url') {
					if (!isset($_SESSION['onethird-plugin-embed-on']) && !empty($page_ar['meta']['plugin_embed'][$m[2]])) {
						$a = $page_ar['meta']['plugin_embed'][$m[2]];
						$pattern = '/((?:https?|ftp):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)/ui';
						$replacement = '<a href="\1">\1</a>';
						$a= preg_replace($pattern,$replacement,$a);

						$pattern =  '/([0-9]{6,9,10,11}|[0-9-]{12,13})/ui';
						$replacement = '<a href="tel:\1">\1</a>';
						$a= preg_replace($pattern,$replacement,$a);
						return $a;
					}
					return plugin_proc('embed','edit',"name:{$m[2]}",'page:self');

				} else if ($m[1] == 'Tag') {
					$t = get_tags($params['page']['tag']);
					$tag = implode($t, ',');
					if (!isset($_SESSION['onethird-plugin-embed-on']) || $_SESSION['onethird-plugin-embed-on']!=$page_ar['id']) {
						if ($t && is_array($t)) {
							$x = '';
							foreach ($t as $v) {
								if ($x) {$x.=',';}
								$x .= "<a href='{$ut->link("search?t=$v")}' />$v</a>";
							}
							return $x;
						}
						return $tag;
					}
					$x = plugin_proc('embed','text',"name:tag",'page:self');
					if (isset($params['circle']['meta']['taglist']) && $params['circle']['meta']['taglist']) {
$x .=  <<<EOT
						<a href="javascript:void(ot.ctypedb_tag_open_close())" style='position: absolute;top: 0;right: 0;'>{$ut->icon('edit'," width='20' ")}</a>
EOT;
						if (isset($params['circle']['meta']['taglist'])) {
							$ar = trim($params['circle']['meta']['taglist'], ',');
							if ($ar && ($ar = explode(',', $ar))) {
$x .=  <<<EOT
								<div class='ctypedb_tag_open_close' style='display:none;' >
EOT;
									foreach($ar as $v) {
										$x .= "<span style='margin:3px 2px 0 0;border:1px solid #c0c0c0;display:inline-block;padding:2px;cursor:pointer'>$v</span>";
									}
$x .=  <<<EOT
								</div>
EOT;
							}
						}
					}
					return $x;
				}
				$x = plugin_proc('embed',$m[1],"name:{$m[2]}",'page:self');
			}
			return $x;
		}
	,$body);

	if (check_rights('owner') && !empty($page_ar['meta']['page_ctypedb_writer']) && $page_ar['meta']['page_ctypedb_writer'] == 'gallery_folder' ) {
$body .= <<<EOT
		<input type='button' value='set thumbnail' onclick='ot.select_thumbnail()' class='onethird-button '/>
EOT;
$html['meta']['get_def_format'] = <<<EOT
	<script>
		\$(function() {
			ot.select_thumbnail = function() {
				opt = {};
				opt.thumb = true;
				opt.title = 'Set Thumbnail';
				opt.resize = "auto,320/240/1";
				opt.select = function(obj){
					ot.set_ogimage(obj,'thumb');
					ot.close_dialog();
				}
				ot.open_uploader(opt);
			};
			\$(function(){
				\$(document).on('click','.ctypedb_tag_open_close span',function(event){
					var o = \$(this).parent();
					var tag = \$('.item-panel .inner[data-name=tag] > input');
					var a = tag.val();
					var x = \$(this);
					var t = x.text();
					if (x.hasClass('sel')) {
						a = (","+a+",").replace(new RegExp(","+t+",", "g"), ',');
					} else {
						a = t+','+a;
					}
					a = a.replace(/,,+/g, ',');
					a = a.replace(/(^,|,\$)/gm, ',');
					a = a.replace(/^[ ,]+|[ ,]+\$/g,'');
					tag.val(a);
					ot.ctypedb_tag_sel();
				});
			});
			ot.ctypedb_tag_sel = function() {
				var str = \$('.item-panel .inner[data-name=tag] > input').val();
				var str = str.replace(/(,| |、|，|　)+/g,',');
				\$('.item-panel .inner[data-name=tag] > input').val(str);
				var ar = str.split(',');
				\$('.ctypedb_tag_open_close span').each(function() {
					var oj = \$(this);
					var s = false;
					var k = oj.text();
					for (var i=0; i<ar.length; ++i) {
						if (k == ar[i]) {s = true;}
					}
					if (s) {
						oj.css('background-color','#c0c0c0').addClass('sel');
					} else {
						oj.css('background-color','#fff').removeClass('sel');
					}
				});
			};
			ot.ctypedb_tag_open_close = function() {
				var obj = \$('.ctypedb_tag_open_close');
				if (obj.css('display')=='none'){
					obj.fadeIn();
					ot.ctypedb_tag_sel();
				} else {
					obj.fadeOut();
				}
			};
		});
	</script>
EOT;
	}
	expand_buff($body);
	return $body;
}

function get_def_format(&$page_ar)
{
	global $params,$config,$ut,$html;

	if (!empty($page_ar['meta']['page_ctypedb_writer']) && $page_ar['meta']['page_ctypedb_writer'] == 'gallery_folder') {
$def_format = <<<EOT
		<div class="onethird-ctypedb" > 
			<div class="table">
				<div class='top-unit'> 
					<div class="item-panel"> 
						<div class='left'> 
							title
						</div>
						<div class='right'> 
							<span class="item" data-type="Title" data-name=""></span>
						</div>
					</div>
					<div class="item-panel"> 
						<div class='left'> 
							date
						</div>
						<div class='right'> 
							<span class="item" data-type="Date" data-name=""></span>
						</div>
					</div>
					<div class="item-panel"> 
						<div class='left'> 
							Option1
						</div>
						<div class='right'> 
							<span class="item" data-type="text" data-name="option1"></span>
						</div>
					</div>
					<div class="item-panel"> 
						<div class='left'> 
							Option2
						</div>
						<div class='right'> 
							<span class="item" data-type="select" data-name="option2,A,B,C"></span>
						</div>
					</div>
				</div>
			</div>
		</div>
EOT;
		return $def_format;
	}


$def_format = <<<EOT
	<div class="onethird-ctypedb" > 
		<div class='top-unit'> 
			<div class="item-panel"> 
				<div class='left'> 
					title
				</div>
				<div class='right'> 
					<span class="item" data-type="Title" data-name=""></span>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					date
				</div>
				<div class='right'> 
					<span class="item" data-type="Date" data-name=""></span>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					Option1
				</div>
				<div class='right'> 
					<span class="item" data-type="text" data-name="option1"></span>
				</div>
			</div>
			<div class="item-panel"> 
				<div class='left'> 
					Option2
				</div>
				<div class='right'> 
					<span class="item" data-type="select" data-name="option2,A,B,C"></span>
				</div>
			</div>
		</div>
	</div>
EOT;
	return $def_format;
}

function snippet_format_js_css()
{
	global $html,$ut,$params;

$html['css']['snippet_format_js_css'] = <<<EOT
<style>
	#ctypedb_toolbar select:disabled,#ctypedb_toolbar .disabled {
		opacity:0.5;
		cursor: not-allowed;
	}
	#_tryitEditor_contents .onethird-ctypedb .item {
		border:1px dotted #CB0F00;
	}
	#_tryitEditor_contents .onethird-ctypedb .item select
	,#_tryitEditor_contents .onethird-ctypedb .item input {
		margin: 2px;
	}
	#_tryitEditor_contents .onethird-ctypedb .item-panel .handle {
		position: absolute;
		top:3px;
		right:3px;
	}
	#_tryitEditor_contents .onethird-ctypedb .item-panel .handle img {
		width:18px;
		margin-left:7px;
		cursor:pointer;
	}
	
</style>
EOT;

$html['meta']['snippet_format_js_css'] = <<<EOT
<script>
	\$(function(){
		ot.editor = ot.editor || {};
		ot.editor.hide_ind = true;
		ot.editor.onready = function() {
			\$('#_tryitEditor_contents .onethird-ctypedb .item').attr('contenteditable','false').each(function(){
				var o = \$(this);
				var h = '';
				h += ot.inpage_write_ctypedb_select_str(o.attr('data-type'));
				h += "<input type='text' value='"+o.attr('data-name')+"' />";
				o.html(h);
			});
			ot.adj_ctypedb_hnd();
			if (!ot.tryitEditor.org_html) {
				ot.tryitEditor.org_html = ot.tryitEditor.html;
				ot.tryitEditor.html = function(a) {
					\$("#_tryitEditor_contents .onethird-ctypedb .handle").remove();
					\$("#_tryitEditor_contents .onethird-ctypedb .item").each(function(){
						var o = \$(this);
						try {
							var t = o.find('select').val();
							o.attr('data-type',t);
							t = o.find('input').val();
							o.attr('data-name',t);
						} catch (e) {
						}
					});
					\$("#_tryitEditor_contents .onethird-ctypedb select").remove();
					\$("#_tryitEditor_contents .onethird-ctypedb input").remove();
					\$("#_tryitEditor_contents .onethird-ctypedb .item").removeAttr('contenteditable');
					
					return ot.tryitEditor.org_html(a);
				}
			}
		}
		ot.inpage_write_ctypedb_select_str = function(x){
			var h = '';
			var ar = ['img','text','select','date','number','time','radio','checkbox','html','Title','Contents','Date','tel','map','url','Tag'];
			h += "<select>";
			for (var i=0; i < ar.length; ++i) {
				var v = ar[i];
				h += "<option value='"+v+"' ";
				if (v == x) {
					h += " selected ";
				}
				h += ">"+v+"</option>";
			}
			h += "</select>";
			return h;
		};
		ot.adj_ctypedb_hnd = function(o){
			if (!o) {
				o = "#_tryitEditor_contents .onethird-ctypedb .item-panel ";
			}
			\$(o).append("<span class='handle'>{$ut->icon('add'," onclick='ot.ctypedb_add(this)' ")}{$ut->icon('remove'," onclick='ot.ctypedb_del(this)' ")}{$ut->icon('up'," onclick='ot.ctypedb_up(this)' ")}{$ut->icon('dn'," onclick='ot.ctypedb_dn(this)' ")}</span>");
		};
		ot.ctypedb_add = function(obj){
			var o = obj.parentElement.parentElement.outerHTML;
			o = \$(o);
			o.find('span.handle').remove();
			ot.adj_ctypedb_hnd(o);
			\$(obj).parents('.item-panel').after(o);
		};
		ot.ctypedb_del = function(obj){
			\$(obj).parents('.item-panel').remove();
		};
		ot.ctypedb_up = function(obj){
			var o = \$(obj).parents('.item-panel');
			var x = o.prev();
			if (x.length) {
				x.before(o);
			}
		};
		ot.ctypedb_dn = function(obj){
			var o = \$(obj).parents('.item-panel');
			var x = o.next();
			if (x != o) {
				x.after(o);
			}
		};
	});
	
</script>
EOT;

}

function csv_export(&$page_ar)
{
	global $database,$ut,$params,$p_circle,$config;
	if (!check_rights('edit'))  {
		exit();
	}
	
	$r = array();
	$r['result'] = false;
	$id = $page_ar['meta']['page_ctypedb_parent'];
	
	$sql = array();
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[1] = array(" where block_type =10");
	$sql[2] = array(" and type <> ? and link=?",PAGE_FOLDER_ID,$id);
	$sql[3] = array(' and mode=1 ');
	
	$ar = $database->sql_select_all($sql);

	
	$buff = '';
	if ($ar) {
		$r['result'] = true;
		$column = array();
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			if (!empty($m['plugin_embed'])) {
				foreach ($m['plugin_embed'] as $k=>$vv) {
					$column[$k] = 0;
				}
			}
		}
		$buff .= "id,date,title";
		foreach ($column as $k=>$v) {
			$k = str_replace(',','',$k);
			$buff .= ",$k";
		}
		$buff .= "\r\n";
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			$t = $v['title'];
			$ico = '';
			if (!$t) { $t = '...'; }
			$u = $ut->link($v['id']);
			if ($v['type'] == PAGE_FOLDER_ID) { $ico = $ut->icon('folder',"width='16'"); }
			if ($v['mode'] == 0) { $t = $t.$ut->icon('lock','width="16"'); }
			$d = substr($v['date'],0,10);
			$t = str_replace(',',' ',$t);
			$k = str_replace(',',' ',$k);
			$buff .= "{$v['id']},$d,$t";
			foreach ($column as $k=>$vv) {
				if (!empty($m['plugin_embed'][$k]) && $m['plugin_embed'][$k]) {
					$x = $m['plugin_embed'][$k];
					$x = strip_tags($x);
					$x = str_replace(',',' ',$x);
					$x = str_replace(';',' ',$x);
					$x = str_replace("\t",' ',$x);
					$x = str_replace("\r",' ',$x);
					$x = str_replace("\n",' ',$x);
					$buff .= ",$x";
				} else {
					$buff .= ",-";
				}
			}
			$buff .= "\r\n";
		}
	}
	header("Content-Type: text/comma-separated-values");
	header("Content-Disposition: attachment; filename=export.csv");
	echo $buff;
	exit();

}

function ctypedb_query( &$page_ar, &$option )
{
	global $params, $ut, $database;

	$id = $page_ar['meta']['page_ctypedb_parent'];

	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = $page_ar['meta']['page_ctypedb_item_count'];

	$offset_name = 'offset';
	$option['offset_name'] = $offset_name;
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}


	$sql = array();
	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	$sql[1] = array(" where block_type =10");
	$sql[2] = array(" and type <> ? and link=?  ",PAGE_FOLDER_ID,$id);

	if (check_rights()) {
		$sql[3] = array(' and (mode=1 or (mode=0 and user=?)) ',(int)($_SESSION['login_id']));
	} else {
		$sql[3] = array(' and mode=1 ');
	}

	// count
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}

	// page
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[2] = array(" and type <> ? and link=?",PAGE_FOLDER_ID,$id);
	if (!empty($page_ar['meta']['page_ctypedb_random'])) {
		$sql[]  = array(" limit 3000 ");
	} else {
		$sql[]  = array(" {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ");
	}
	
	$ar = $database->sql_select_all($sql);

	/*
	// foloder
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[2] = array(" and type=? and link=?",PAGE_FOLDER_ID,$id);
	$sql[4] = array("order by date desc");
	$folder_ar = $database->sql_select_all($sql);

	if ($folder_ar) {
		$ar = array_merge($folder_ar,$ar);
	}
	*/
	if (!empty($page_ar['meta']['page_ctypedb_random'])) {
		shuffle($ar);
	}
	return $ar;
}

function ctypedb_folder( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;


	$add_type = 1;
	$folder_type = PAGE_FOLDER_ID;
	$id = $page_ar['meta']['page_ctypedb_parent'];
	
	$ar = ctypedb_query( $page_ar, $option );

	$buff = '';
	$buff .= std_pagination_renderer( $option );
	if ($option['total'] > 3) {
		$buff .=  "<p>{$option['total']} items</p>";
	}
	$edit = false;
	if (check_rights('owner')) {
		if (isset($_GET['mode']) && $_GET['mode'] == 'edit_column') {
			$edit = true;
$buff .= <<<EOT
			<div class="edit_pointer " >
				<a href='{$ut->link($page_ar['id'])}' class='onethird-button mini'>quit</a>
				<a href='{$ut->link(0)}' class='onethird-button mini'>reset column</a>
			</div>
EOT;
		} else {
$buff .= <<<EOT
			<div class="edit_pointer " >
				<a href='{$ut->link($page_ar['id'],'&:mode=edit_column')}' class='onethird-button mini'>edit column</a>
			</div>
EOT;
		}
	}
	$nt = time();
	if ($ar) {
		$column = array();
		foreach ($ar as &$v) {
			$m = $v['meta'] = unserialize64($v['metadata']);
			if (!empty($m['plugin_embed'])) {
				foreach ($m['plugin_embed'] as $k=>$vv) {
					if (!isset($page_ar['meta']['page_ctypedb_discolumn'][$k])) {
						$column[$k] = 0;
					}
				}
			}
		}
		unset($v);
$buff .= <<<EOT
		<table class='onethird-table'>
			<tr>
				<th>date</th><th>title</th>
EOT;
				$i = 1;
				foreach ($column as $k=>$v) {
					if ($edit) {
$buff .= <<<EOT
						<th>$k <a href='javascript:void(ctypedb_remove_column({$i}))'>{$ut->icon('delete')}</a></th>
EOT;
						++$i;
					} else {
$buff .= <<<EOT
						<th>$k</th>
EOT;
					}
				}
$buff .= <<<EOT
			</tr>
EOT;
			foreach ($ar as $v) {
				$m = $v['meta'];
				$t = $v['title'];
				$ico = '';
				if (!$t) { $t = '...'; }
				$u = $ut->link($v['id']);
				if ($v['type'] == PAGE_FOLDER_ID) { $ico = $ut->icon('folder',"width='16'"); }
				if ($v['mode'] == 0) { $t = $t.$ut->icon('lock','width="16"'); }
				$d = substr($v['date'],0,10);
$buff .= <<<EOT
				<tr>
					<td><a href='{$ut->link($v['id'])}'>$d</a></td>
					<td>$t</td>
EOT;
				foreach ($column as $k=>$vv) {
					if (!empty($m['plugin_embed'][$k]) && $m['plugin_embed'][$k]) {
$buff .= <<<EOT
						<td>{$m['plugin_embed'][$k]}</td>
EOT;
					} else {
$buff .= <<<EOT
						<td></td>
EOT;
					}
				}
$buff .= <<<EOT
				</tr>
EOT;
			}
$buff .= <<<EOT
		</table>
EOT;
	}
	
	if (check_func_rights('add_data_items') || check_rights('edit')) {
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='Add page' class='onethird-button mini' onclick='ot.plugin_ctypedb_make_page({$id}, $add_type)' />
			<!--
			<input type='button' value='Add folder' class='onethird-button mini' onclick='ot.plugin_ctypedb_make_page({$id}, $folder_type)' />
			-->
		</p>
EOT;
	}

$html['meta']['ctypedb_folder'] = <<<EOT
	<script>
	function ctypedb_remove_column(id) {
		var opt = "ajax=ctypedb_remove_column&id="+id;
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: opt
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					location.reload(true);
				} else {
					alert('error');
				}
			}
		});
	};
	</script>
EOT;
	
	if (check_rights('owner') && isset($_POST['ajax']) && $_POST['ajax'] == 'ctypedb_remove_column')  {
		$r = array();
		$r['result'] = false;
		$r['id'] = (int)$_POST['id'];
		$i = $r['id'];
		if ($i >0) {
			foreach ($column as $k=>$v) {
				if (--$i == 0) {
					$r['column'] = $k;
					$page_ar['meta']['page_ctypedb_discolumn'][$k] = true;
					$page_ar['metadata'] = serialize64($page_ar['meta']);
					if (mod_data_items($page_ar)) {
						$r['result'] = true;
					}
					break;
				}
			}
		} else {
			unset($page_ar['meta']['page_ctypedb_discolumn']);
			$page_ar['metadata'] = serialize64($page_ar['meta']);
			if (mod_data_items($page_ar)) {
				$r['result'] = true;
			}
		}
		echo(json_encode($r));
		exit();
	}

	$html['article'][] = frame_renderer($buff,'plugin-page-folder-unit');
}

function gallery_folder( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar,$config;

$html['css']['ctypedb-folder'] = <<<EOT
	<style>
	#ctypedb_folder {
		margin:0;
		padding:0;
	}
	#ctypedb_folder .item {
		position: relative;
		display:inline-block;
		width:160px;
		height:200px;
		cursor:pointer;
	}
	#ctypedb_folder .item .inner {
		position: relative;
		margin:0 5px 20px 5px;
		height:100%;
		border:1px solid #c0c0c0;
		overflow:hidden;
		padding:5px;
		box-sizing: border-box;
	    background-color: #FFF;
	}
	#ctypedb_folder .item .inner .title {
		position: absolute;
		bottom: 0;
		left: 0;
		background-color: #fff;
		width:100%;
		margin:0;
		padding:5px;
		min-height:70px;
    }
	#ctypedb_folder .item .inner .image {
		box-sizing: border-box;
		overflow:hidden;
	}
	#ctypedb_folder .item .inner .image img {
		width: 187%;
		margin-left: -43%;
		margin-top: -13%;
	}
	#ctypedb_folder .item .inner .title a {
		color: #000;
		font-size: 15px;
		font-weight: bold;
		overflow: hidden;
		width: 100%;
		display: inline-block;
		height: 1em;
		line-height: 100%;
	}
	#ctypedb_folder .item .inner .description {
		font-size: 12px;
		padding: 5px 10px 0 0;
		line-height: 18px;
		color: #525252;
	}
	@media screen and (max-width:320px) {
		#ctypedb_folder .item .inner .title a {
			font-size: 13px;
		}
		#ctypedb_folder .item .inner .description {
			font-size: 10px;
		}
		#ctypedb_folder .item {
			width:120px;
			height:200px;
			cursor:pointer;
		}
	}
	</style>
EOT;

$html['meta']['ctypedb-folder-resize'] = <<<EOT
	<script>
	\$(function(){
		ot.ctypedb_folder_onresize = function() {
			var obj = \$('#ctypedb_folder');
			var w = obj.width();
			if (!ot.ctypedb_folder_width || ot.ctypedb_folder_width - 10 > w || ot.ctypedb_folder_width  + 10 < w) {
				ot.ctypedb_folder_width = w;
				var o = \$('#ctypedb_folder .item');
				if (!ot.ctypedb_folder_item_width) {
					ot.ctypedb_folder_item_width = o.width() ;
				}
				a = parseInt(ot.ctypedb_folder_width /ot.ctypedb_folder_item_width);
				d = (100/a-0.01).toFixed(2);
				o.css('width',d+'%');
			}
		}
		\$(window).on('resize', function(){
			ot.ctypedb_folder_onresize();
		});
		ot.ctypedb_folder_onresize();
	});
	</script>
EOT;


	$add_type = 1;
	$folder_type = PAGE_FOLDER_ID;
	$id = $page_ar['meta']['page_ctypedb_parent'];
	
	$ar = ctypedb_query( $page_ar, $option );

	$buff = '';
	if (empty($page_ar['meta']['page_ctypedb_random'])) {
		$buff .= std_pagination_renderer( $option );
	}
	$nt = time();


$buff .= <<<EOT
	<div id='ctypedb_folder'>
EOT;
		$i = $option['page_size']+1;
		foreach ($ar as $v) {
			if (--$i <= 0) { break; }
			$m = unserialize64($v['metadata']);
			$t = $v['title'];
			$ico = '';
			if (!$t) { $t = '...'; }
			$u = $ut->link($v['id']);
			if ($v['type'] == PAGE_FOLDER_ID) { $ico = $ut->icon('folder',"width='16'"); }
			if ($v['mode'] == 0) { $t = $t.$ut->icon('lock','width="16"'); }
			$d = substr($v['date'],0,10);
			$img = "{$config['site_url']}css/onethird121.png";
			if (isset($m['thumb_img'])) {
				$img = $config['files_url']."img/{$v['id']}/{$m['thumb_img']}";
			}
			$description = '';
			if (!empty($m['description'])) {
				$description = adjust_mstring($m['description'],45);
			}
$tmp = <<<EOT
			<div class='item' onclick="window.open('{$ut->link($v['id'])}','_blank')" >
				<div class='inner'>
					<div  class='image'>
						<img src='{$img}' />
					</div>
					<div class='title'>
						<a href='{$ut->link($v['id'])}' target='_blank' >$t</a>
						<div class='description'>
							{$description}
						</div>
					</div>
				</div>
			</div>
EOT;
			$buff .= trim($tmp);
		}

$buff .= <<<EOT
	</div>
EOT;
	
	if (check_func_rights('add_data_items') || check_rights('edit')) {
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='Add page' class='onethird-button mini' onclick='ot.plugin_ctypedb_make_page({$id}, $add_type)' />
			<!--
			<input type='button' value='Add folder' class='onethird-button mini' onclick='ot.plugin_ctypedb_make_page({$id}, $folder_type)' />
			-->
		</p>
EOT;
	}

	$html['article'][] = frame_renderer($buff,'plugin-page-folder-unit');
}


?>